<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd"><html xmlns="http://www.w3.org/1999/xhtml"><head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.20"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<a class="dashingAutolink" name="autolink-319"></a><a class="dashAnchor" name="//apple_ref/cpp/Package/XHXKit%3A%20%2FUsers%2Fscar1900%2FDeveloper%2FXHXKit%2FXHXKit%2FClasses%2FQRCode%2FXHXQRCodeTools.m%20%E6%BA%90%E6%96%87%E4%BB%B6"></a><title>XHXKit: /Users/scar1900/Developer/XHXKit/XHXKit/Classes/QRCode/XHXQRCodeTools.m 源文件</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css"/>
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">XHXKit
   &nbsp;<span id="projectnumber">4.10.0.12</span>
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- 制作者 Doxygen 1.8.20 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'搜索');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','搜索');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow" onmouseover="return searchBox.OnSearchSelectShow()" onmouseout="return searchBox.OnSearchSelectHide()" onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="dir_d522931ffa1371640980b621734a4381.html">Users</a></li><li class="navelem"><a class="el" href="dir_2f48480e0fdb0436fb8fd57a1ed5f613.html">scar1900</a></li><li class="navelem"><a class="el" href="dir_c8b33409012acfc781ba898892fd3b4c.html">Developer</a></li><li class="navelem"><a class="el" href="dir_0e1030ab80149b7e8d6dfd17946e9c40.html">XHXKit</a></li><li class="navelem"><a class="el" href="dir_c9ece41fcb3917ec137dcec44cd0055f.html">XHXKit</a></li><li class="navelem"><a class="el" href="dir_3a9521ad7c4429598be7e28fa39d3d14.html">Classes</a></li><li class="navelem"><a class="el" href="dir_606effedd7f553d1cd542e9dd5d5ce47.html">QRCode</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="headertitle">
<div class="title">XHXQRCodeTools.m</div>  </div>
</div><!--header-->
<div class="contents">
<a href="_x_h_x_q_r_code_tools_8m.html">浏览该文件的文档.</a><div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno"><a class="line" href="interface_x_h_x_q_r_code_tools.html#aae636aed99d415a3a97b398455bddee2">    1</a></span>&nbsp;<span class="comment">//</span></div>
<div class="line"><a name="l00002"></a><span class="lineno">    2</span>&nbsp;<span class="comment">//  XHXQRCodeTools.m</span></div>
<div class="line"><a name="l00003"></a><span class="lineno">    3</span>&nbsp;<span class="comment">//  YXSNetwork_Example</span></div>
<div class="line"><a name="l00004"></a><span class="lineno">    4</span>&nbsp;<span class="comment">//</span></div>
<div class="line"><a name="l00005"></a><span class="lineno">    5</span>&nbsp;<span class="comment">//  Created by 袁培超 on 2019/3/4.</span></div>
<div class="line"><a name="l00006"></a><span class="lineno">    6</span>&nbsp;<span class="comment">//  Copyright &copy; 2019 袁培超. All rights reserved.</span></div>
<div class="line"><a name="l00007"></a><span class="lineno">    7</span>&nbsp;<span class="comment">//</span></div>
<div class="line"><a name="l00008"></a><span class="lineno">    8</span>&nbsp; </div>
<div class="line"><a name="l00009"></a><span class="lineno">    9</span>&nbsp;<span class="preprocessor">#import &#34;<a class="code" href="_x_h_x_q_r_code_tools_8h.html">XHXQRCodeTools.h</a>&#34;</span></div>
<div class="line"><a name="l00010"></a><span class="lineno">   10</span>&nbsp; </div>
<div class="line"><a name="l00011"></a><span class="lineno">   11</span>&nbsp;<span class="keyword">@implementation </span><a class="code" href="interface_x_h_x_q_r_code_tools.html">XHXQRCodeTools</a></div>
<div class="line"><a name="l00012"></a><span class="lineno">   12</span>&nbsp;+ (UIImage *)creatQRCodeWithData:(NSString *)inputMessage  {</div>
<div class="line"><a name="l00013"></a><span class="lineno">   13</span>&nbsp;    <span class="comment">//创建过滤器</span></div>
<div class="line"><a name="l00014"></a><span class="lineno">   14</span>&nbsp;    CIFilter *filter = [CIFilter filterWithName:@&#34;CIQRCodeGenerator&#34;];</div>
<div class="line"><a name="l00015"></a><span class="lineno">   15</span>&nbsp;    </div>
<div class="line"><a name="l00016"></a><span class="lineno">   16</span>&nbsp;    <span class="comment">//设置过滤器默认属性</span></div>
<div class="line"><a name="l00017"></a><span class="lineno">   17</span>&nbsp;    [filter setDefaults];</div>
<div class="line"><a name="l00018"></a><span class="lineno">   18</span>&nbsp;    </div>
<div class="line"><a name="l00019"></a><span class="lineno">   19</span>&nbsp;    <span class="comment">//将NSString格式转化成NSData格式</span></div>
<div class="line"><a name="l00020"></a><span class="lineno">   20</span>&nbsp;    NSData *data = [inputMessage dataUsingEncoding:NSUTF8StringEncoding allowLossyConversion:YES];</div>
<div class="line"><a name="l00021"></a><span class="lineno">   21</span>&nbsp;    </div>
<div class="line"><a name="l00022"></a><span class="lineno">   22</span>&nbsp;    <span class="comment">/*</span></div>
<div class="line"><a name="l00023"></a><span class="lineno">   23</span>&nbsp;<span class="comment">     inputMessage,        //二维码输入信息</span></div>
<div class="line"><a name="l00024"></a><span class="lineno">   24</span>&nbsp;<span class="comment">     */</span></div>
<div class="line"><a name="l00025"></a><span class="lineno">   25</span>&nbsp;    [filter setValue:data forKeyPath:@&#34;inputMessage&#34;];</div>
<div class="line"><a name="l00026"></a><span class="lineno">   26</span>&nbsp;    <span class="comment">//设置二维码的纠错水平，越高纠错水平越高，可以污损的范围越大</span></div>
<div class="line"><a name="l00027"></a><span class="lineno">   27</span>&nbsp;    <span class="comment">/*</span></div>
<div class="line"><a name="l00028"></a><span class="lineno">   28</span>&nbsp;<span class="comment">     * L: 7%</span></div>
<div class="line"><a name="l00029"></a><span class="lineno">   29</span>&nbsp;<span class="comment">     * M: 15%</span></div>
<div class="line"><a name="l00030"></a><span class="lineno">   30</span>&nbsp;<span class="comment">     * Q: 25%</span></div>
<div class="line"><a name="l00031"></a><span class="lineno">   31</span>&nbsp;<span class="comment">     * H: 30%</span></div>
<div class="line"><a name="l00032"></a><span class="lineno">   32</span>&nbsp;<span class="comment">     */</span></div>
<div class="line"><a name="l00033"></a><span class="lineno">   33</span>&nbsp;    [filter setValue:@&#34;H&#34; forKey:@&#34;inputCorrectionLevel&#34;];</div>
<div class="line"><a name="l00034"></a><span class="lineno">   34</span>&nbsp;    <span class="comment">//获取二维码过滤器生成的二维码</span></div>
<div class="line"><a name="l00035"></a><span class="lineno">   35</span>&nbsp;    CIImage *QRImage = [filter outputImage];</div>
<div class="line"><a name="l00036"></a><span class="lineno">   36</span>&nbsp;    <span class="comment">//图片需要放大到合适尺寸  默认是 (23,23)</span></div>
<div class="line"><a name="l00037"></a><span class="lineno">   37</span>&nbsp;    QRImage = [QRImage imageByApplyingTransform:CGAffineTransformMakeScale(20, 20)];</div>
<div class="line"><a name="l00038"></a><span class="lineno">   38</span>&nbsp;    </div>
<div class="line"><a name="l00039"></a><span class="lineno">   39</span>&nbsp;    <span class="keywordflow">return</span> [UIImage imageWithCIImage:QRImage];</div>
<div class="line"><a name="l00040"></a><span class="lineno">   40</span>&nbsp;}</div>
<div class="line"><a name="l00041"></a><span class="lineno">   41</span>&nbsp;<span class="comment">//中心图片和QRImage比例为  2/7</span></div>
<div class="line"><a name="l00042"></a><span class="lineno">   42</span>&nbsp;+ (UIImage *)creatQRCodeWithData:(NSString *)inputMessage centerImage:(UIImage *)centerImage {</div>
<div class="line"><a name="l00043"></a><span class="lineno">   43</span>&nbsp;    UIImage *QRImage = [<a class="code" href="interface_x_h_x_q_r_code_tools.html">XHXQRCodeTools</a> <a class="code" href="interface_x_h_x_q_r_code_tools.html#af4b2fa46013c54070417f20d4d81049d">creatQRCodeWithData</a>:inputMessage];</div>
<div class="line"><a name="l00044"></a><span class="lineno">   44</span>&nbsp;    <span class="comment">//开启图形上下文</span></div>
<div class="line"><a name="l00045"></a><span class="lineno">   45</span>&nbsp;    UIGraphicsBeginImageContext(QRImage.size);</div>
<div class="line"><a name="l00046"></a><span class="lineno">   46</span>&nbsp;    <span class="comment">//将二维码的图片画入</span></div>
<div class="line"><a name="l00047"></a><span class="lineno">   47</span>&nbsp;    [QRImage drawInRect:CGRectMake(0, 0, QRImage.size.width, QRImage.size.height)];</div>
<div class="line"><a name="l00048"></a><span class="lineno">   48</span>&nbsp;    <span class="comment">//在中心划入其他图片</span></div>
<div class="line"><a name="l00049"></a><span class="lineno">   49</span>&nbsp;    CGFloat centerW=(QRImage.size.width/7)*2;</div>
<div class="line"><a name="l00050"></a><span class="lineno">   50</span>&nbsp;    CGFloat centerX=(QRImage.size.width-centerW)/2;</div>
<div class="line"><a name="l00051"></a><span class="lineno">   51</span>&nbsp;    CGFloat centerY=(QRImage.size.width-centerW)/2;</div>
<div class="line"><a name="l00052"></a><span class="lineno">   52</span>&nbsp;    [centerImage drawInRect:CGRectMake(centerX, centerY, centerW, centerW)];</div>
<div class="line"><a name="l00053"></a><span class="lineno">   53</span>&nbsp;    <span class="comment">//获取绘制好的图片</span></div>
<div class="line"><a name="l00054"></a><span class="lineno">   54</span>&nbsp;    UIImage *finalImg=UIGraphicsGetImageFromCurrentImageContext();</div>
<div class="line"><a name="l00055"></a><span class="lineno">   55</span>&nbsp;    <span class="comment">//关闭图像上下文</span></div>
<div class="line"><a name="l00056"></a><span class="lineno">   56</span>&nbsp;    UIGraphicsEndImageContext();</div>
<div class="line"><a name="l00057"></a><span class="lineno">   57</span>&nbsp;    <span class="keywordflow">return</span> finalImg;</div>
<div class="line"><a name="l00058"></a><span class="lineno">   58</span>&nbsp;    </div>
<div class="line"><a name="l00059"></a><span class="lineno">   59</span>&nbsp;}</div>
<div class="line"><a name="l00060"></a><span class="lineno">   60</span>&nbsp;<span class="keyword">@end</span></div>
</div><!-- fragment --></div><!-- contents -->
<div class="ttc" id="ainterface_x_h_x_q_r_code_tools_html_af4b2fa46013c54070417f20d4d81049d"><div class="ttname"><a href="interface_x_h_x_q_r_code_tools.html#af4b2fa46013c54070417f20d4d81049d">+[XHXQRCodeTools creatQRCodeWithData:]</a></div><div class="ttdeci">UIImage * creatQRCodeWithData:(NSString *inputMessage)</div><div class="ttdef"><b>Definition:</b> <a href="_x_h_x_q_r_code_tools_8m_source.html#l00001">XHXQRCodeTools.m:12</a></div></div>
<div class="ttc" id="ainterface_x_h_x_q_r_code_tools_html"><div class="ttname"><a href="interface_x_h_x_q_r_code_tools.html">XHXQRCodeTools</a></div><div class="ttdef"><b>Definition:</b> <a href="_x_h_x_q_r_code_tools_8h_source.html#l00013">XHXQRCodeTools.h:14</a></div></div>
<div class="ttc" id="a_x_h_x_q_r_code_tools_8h_html"><div class="ttname"><a href="_x_h_x_q_r_code_tools_8h.html">XHXQRCodeTools.h</a></div></div>
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
制作者&nbsp;<a href="http://www.doxygen.org/index.html"><img class="footer" src="doxygen.svg" width="104" height="31" alt="doxygen"/></a> 1.8.20
</small></address>


</body></html>